unit NestedClass;

interface

type
  TOne = class
//  private
    // nested constant
    const foo = 12;
    // nested type
    type TInside = class
      type TInsideInside = class
        procedure Two;
      end;
    public
      procedure InsideHello;
    private
      Msg: string;
      InsIns: TInsideInside;
    end;
  public
    procedure Hello;
    constructor Create;
  end;

implementation

uses
  SysUtils;

{ TOne }

procedure TOne.Hello;
var
  ins: TInside;
begin
  ins := TInside.Create;
  ins.InsideHello;
  writeln ('constant is ' + IntToStr (foo));
end;

{ TOne.TInside }

procedure TOne.TInside.InsideHello;
begin
   writeln ('internal call');
   if not Assigned (InsIns) then
     InsIns := TInsideInside.Create;
   InsIns.Two;
end;

{ TOne.TInside.TInsideInside }

procedure TOne.TInside.TInsideInside.Two;
begin
  writeln ('this is a method of a nested/nested class');
end;

end.
